#ifndef CYCL_HH
#define CYCL_HH

#include <assert.h>
template<class T>
class Cyclic_buffer {
    T* array;

public:
    int len;
    int free, end;
    Cyclic_buffer(int l)
    {
	len=l;
	array=new T[len];
	free = end = 0;
    }
    T &operator[](int i ){
	assert( i >= 0 && i < len);
	return array[i];
    }
    const T &operator[](int i ) const {
	assert( i >= 0 && i < len);
	return array[i];
    }
    T & last() {
	if (end  < len)
	    return array[0];
	else
	    return array[(free+len - 1)%len];       	    
    }
    void add(T k)
    {
	array[free] = k;
	if (end < len)
	    end ++;
	
	free = (free+1)%len;	
    }	    
};


#endif
