//-*-C++-*-
#ifndef _RECORDER_H_
#define _RECORDER_H_
#include <iostream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#include "vray.hh"
#include "break.hh"
typedef double Real;

#include "cycl.h"
struct Recorder {
    Cyclic_buffer<Time> intervals;
    svec<Break*> breaks_;
    svec<int> sofar_;
    
    int lastcod;
    Time lasttime;
    unsigned int last_programclock;
    Recorder(int keybuflen);

    void add_break(Break &br)
    {
	breaks_.add(&br);
	sofar_.add(0);
    }
    void resetBreak(const Break*);
    int getsofar(const Break *) const;
    float getspeed() const ;
    void process_breaks(unsigned int, bool newkey=true);
    
    void update( unsigned int milisec ) ;
    void record( XKeyEvent &event, unsigned mytime ) ;
};

#endif
